<template>
  <section table-editor>
    <p v-if="error">Error: {{ error }}</p>
    <div loading v-else-if="!columns.columns || !prescales.prescales">loading...</div>
    <template v-else>
      <table option-gray-zeros option-sticky-headers>
        <thead>
          <tr>
            <th>L1 Algo</th>
            <th v-for="column in columns.columns" :key="column.name">
              {{ column.name }}
            </th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="(prescales, name) in prescales.prescales.algorithms"
            :key="name"
            :iszero="isEmptyRow(prescales)"
          >
            <td>{{ name }}</td>
            <td v-for="(prescale, i) in prescales.columns" :key="prescale">
              <input
                type="number"
                step="0.01"
                :iszero="prescale == 0"
                :value="prescale"
                placeholder=""
                @change="e => updatePrescale(name, i, e.target.value)"
              />
            </td>
          </tr>
        </tbody>
      </table>
    </template>
  </section>
</template>

<script lang="ts">
import { ref, defineComponent, onMounted, watchEffect } from "vue";
import { vueMessageHandler, sendMessage } from "../lib/vscode";
import { PrescalesDocument } from "../../../../../types/prescalesDocument";
import { ColumnsDocument } from "../../../../../types/columnsDocument";
import { L1Prescales } from "../../../../../types/l1Prescales";

export default defineComponent({
  name: "TableEditor",
  setup() {
    const prescales = ref({} as PrescalesDocument<L1Prescales>);
    const columns = ref({} as ColumnsDocument);
    const error = ref("");

    let watchEffectDisabled = false;
    vueMessageHandler("file-changed", m => {
      try {
        const json = JSON.parse(m.payload.fileContent);
        watchEffectDisabled = true;
        if (m.payload.name === "l1-prescales") {
          prescales.value = json;
        } else if (m.payload.name === "columns") {
          columns.value = json;
        }
      } catch (e) {
        error.value = e;
      }
    });
    onMounted(() => sendMessage({type: "ready", payload: {}}));

    watchEffect(() => {
      if (!prescales.value.prescales) {
        return;
      }
      // this line needs to be on top, to make sure to 'mark' the document.value proxy on initial run
      const fileContent = JSON.stringify(prescales.value, null, 2);

      if (watchEffectDisabled) {
        watchEffectDisabled = false;
        return;
      }

      sendMessage({
        type: "file-changed",
        payload: {
          name: "l1-prescales",
          fileContent,
        },
      });
    });

    watchEffect(() => {      
      if (!columns.value.columns) {
        return;
      }

      // this line needs to be on top, to make sure to 'mark' the document.value proxy on initial run
      const fileContent = JSON.stringify(columns.value, null, 2);

      if (watchEffectDisabled) {
        watchEffectDisabled = false;
        return;
      }

      sendMessage({
        type: "file-changed",
        payload: {
          name: "columns",
          fileContent,
        },
      });
    });


    // function updatePrescale(algoname: string, index: number, prescale: string) {

    //   // setting expectUpdate to true will prevent a nasty forced redraw of the page
    //   // but that redraw also enables style updates, like the fade-out when setting a prescale to 0 
    //   expectUpdate = parsed.value.l1.prescales.algorithms[algoname].columns[index] !== 0 && Number(prescale) !== 0;
      
    //   parsed.value.l1.prescales.algorithms[algoname].columns[index] = Number(
    //     prescale,
    //   );
    //   sendMessage(
    //     makeMessage("fileContent", [
    //       {
    //         uri: "l1.json",
    //         content: JSON.stringify(parsed.value.l1, null, 2),
    //       },
    //     ]),
    //   );
    // }

    function updatePrescale(algoname: string, index: number, prescale: string) {
      prescales.value.prescales.algorithms[algoname].columns[index] = Number(prescale);
    }
    
    function isEmptyRow(prescales: {columns: number[]}) {
      return !prescales.columns.find(p => p !== 0);
    }
    return {
      prescales,
      columns,
      error,
      updatePrescale,
      isEmptyRow,
    };
  },
});
</script>

<style lang="scss" scoped>
table {
  th,
  td {
    border-right: 1px solid #ffffff62;
    border-bottom: 1px solid #ffffff28;
    margin: 5px;
    padding: 0;
  }
  tbody {
    td {
      input {
        margin: 0 3px;
        min-width: 0;
        width: 100%;
        background: 0;
        color: var(--vscode-editor-foreground);
        border: 0;
      }
    }
  }

  &[option-gray-zeros] {
    tr:not([iszero="true"]) td input[iszero="true"],
    tr[iszero="true"] td {
      opacity: .3;
    }
  }
  &[option-sticky-headers] {
    th {
      background: var(--vscode-editor-background);
      position: sticky;
      top: 0; /* required for the stickiness */
    }
  }
}
</style>
